/* ****************************************************************************
 *
 * Copyright (c) Microsoft Corporation. 
 *
 * This source code is subject to terms and conditions of the Microsoft Public License. A 
 * copy of the license can be found in the License.html file at the root of this distribution. If 
 * you cannot locate the  Microsoft Public License, please send an email to 
 * dlr@microsoft.com. By using this source code in any fashion, you are agreeing to be bound 
 * by the terms of the Microsoft Public License.
 *
 * You must not remove this notice, or any other, from this software.
 *
 *
 * ***************************************************************************/
using System; using Microsoft;


namespace Microsoft.Scripting.Actions {
    internal static partial class MatchCaller {
        #region Generated Matchcaller Targets

        // *** BEGIN GENERATED CODE ***
        // generated by function: gen_matchcaller_targets from: generate_dynsites.py

        /// Matchcaller - arity 1
        internal static object Call1<T0, TRet>(Func<CallSite, T0, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0]);
        }

        /// Matchcaller - arity 2
        internal static object Call2<T0, T1, TRet>(Func<CallSite, T0, T1, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1]);
        }

        /// Matchcaller - arity 3
        internal static object Call3<T0, T1, T2, TRet>(Func<CallSite, T0, T1, T2, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2]);
        }

        /// Matchcaller - arity 4
        internal static object Call4<T0, T1, T2, T3, TRet>(Func<CallSite, T0, T1, T2, T3, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3]);
        }

        /// Matchcaller - arity 5
        internal static object Call5<T0, T1, T2, T3, T4, TRet>(Func<CallSite, T0, T1, T2, T3, T4, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4]);
        }

        /// Matchcaller - arity 6
        internal static object Call6<T0, T1, T2, T3, T4, T5, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5]);
        }

        /// Matchcaller - arity 7
        internal static object Call7<T0, T1, T2, T3, T4, T5, T6, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6]);
        }

        /// Matchcaller - arity 8
        internal static object Call8<T0, T1, T2, T3, T4, T5, T6, T7, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7]);
        }

        /// Matchcaller - arity 9
        internal static object Call9<T0, T1, T2, T3, T4, T5, T6, T7, T8, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8]);
        }

        /// Matchcaller - arity 10
        internal static object Call10<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9]);
        }

        /// Matchcaller - arity 11
        internal static object Call11<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9], (T10)args[10]);
        }

        /// Matchcaller - arity 12
        internal static object Call12<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9], (T10)args[10], (T11)args[11]);
        }

        /// Matchcaller - arity 13
        internal static object Call13<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, TRet>(Func<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, TRet> target, CallSite site, object[] args) {
            return (object)target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9], (T10)args[10], (T11)args[11], (T12)args[12]);
        }


        // *** END GENERATED CODE ***

        #endregion

        #region Generated Matchcaller Void Targets

        // *** BEGIN GENERATED CODE ***
        // generated by function: gen_void_matchcaller_targets from: generate_dynsites.py

        // Matchcaller - arity 1
        internal static object CallVoid1<T0>(Action<CallSite, T0> target, CallSite site, object[] args) {
            target(site, (T0)args[0]);
            return null;
        }

        // Matchcaller - arity 2
        internal static object CallVoid2<T0, T1>(Action<CallSite, T0, T1> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1]);
            return null;
        }

        // Matchcaller - arity 3
        internal static object CallVoid3<T0, T1, T2>(Action<CallSite, T0, T1, T2> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2]);
            return null;
        }

        // Matchcaller - arity 4
        internal static object CallVoid4<T0, T1, T2, T3>(Action<CallSite, T0, T1, T2, T3> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3]);
            return null;
        }

        // Matchcaller - arity 5
        internal static object CallVoid5<T0, T1, T2, T3, T4>(Action<CallSite, T0, T1, T2, T3, T4> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4]);
            return null;
        }

        // Matchcaller - arity 6
        internal static object CallVoid6<T0, T1, T2, T3, T4, T5>(Action<CallSite, T0, T1, T2, T3, T4, T5> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5]);
            return null;
        }

        // Matchcaller - arity 7
        internal static object CallVoid7<T0, T1, T2, T3, T4, T5, T6>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6]);
            return null;
        }

        // Matchcaller - arity 8
        internal static object CallVoid8<T0, T1, T2, T3, T4, T5, T6, T7>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6, T7> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7]);
            return null;
        }

        // Matchcaller - arity 9
        internal static object CallVoid9<T0, T1, T2, T3, T4, T5, T6, T7, T8>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8]);
            return null;
        }

        // Matchcaller - arity 10
        internal static object CallVoid10<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9]);
            return null;
        }

        // Matchcaller - arity 11
        internal static object CallVoid11<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9], (T10)args[10]);
            return null;
        }

        // Matchcaller - arity 12
        internal static object CallVoid12<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9], (T10)args[10], (T11)args[11]);
            return null;
        }

        // Matchcaller - arity 13
        internal static object CallVoid13<T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12>(Action<CallSite, T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12> target, CallSite site, object[] args) {
            target(site, (T0)args[0], (T1)args[1], (T2)args[2], (T3)args[3], (T4)args[4], (T5)args[5], (T6)args[6], (T7)args[7], (T8)args[8], (T9)args[9], (T10)args[10], (T11)args[11], (T12)args[12]);
            return null;
        }


        // *** END GENERATED CODE ***

        #endregion
    }
}
